
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
284
285
286
287
288
289
290
291
292
293
294
295
296
297
298
299
300
301
302
303
304
305
306
307
308
309
310
311
312
313
314
315
316
317
318
319
320
321
322
323
324
325
326
327
328
329
330
331
332
333
334
335
336
337
338
339
340
341
342
343
344
345
346
347
348
349
350
351
352
module.exports = PanoramaModule = {

    Panorama: {

        // Global variables to store configuration

        coordinates: null,

        iFrameRequestUrl: null,

        panoramaContainer: null,

        iFrameElement: null,

        panoramaClickCheckBox: null,

        closeButton: null,

        keyboardMovementEnabled: null,

        mapClickEnabled: null,

        markerImage: null,

        mapLibreMap: null,

        maplibreMarker: null,

        // Variable to store whether the panorama is loaded or not

        panoramaLoaded: false,

        orientation: null,

        ttRight: null,

        ttBottom: null,

        /**

         * @param {number} x The x coordinate, given in epsg:4326

         * @param {number} y The y coordinate, given in epsg:4326

         */

        // Opens the panorama at the location x,y

        OpenPanoramaOnLocation: function (x, y, orientation) {

            // If panorama is closed, open it

            if (PanoramaModule.Panorama.panoramaContainer.style.display == 'none') {

                // Open panorama

                PanoramaModule.Panorama.OpenPanoramaFrame([x, y], orientation);

                // If panorama is not loaded yet

                if (PanoramaModule.Panorama.panoramaLoaded === false) {

                    // Repeat this function until panorama is loaded

                    timer = setTimeout(function () {

                        PanoramaModule.Panorama.OpenPanoramaOnLocation(x, y, orientation);

                    }, 50);

                }

            }

            // If panorama is not loaded yet

            else if (PanoramaModule.Panorama.panoramaLoaded === false) {

                // Repeat this function until panorama is loaded

                timer = setTimeout(function () {

                    PanoramaModule.Panorama.OpenPanoramaOnLocation(x, y, orientation);

                }, 50);

            }

            // If panorama is loaded

            else {

                // If keyboard movement is enabled

                if (PanoramaModule.Panorama.keyboardMovementEnabled == true) {

                    // Send this message once

                    PanoramaModule.Panorama.keyboardMovementEnabled = false;

                    PanoramaModule.Panorama.iFrameElement.contentWindow.postMessage({ keyboardEnabled: true }, '*');

                }

                if (PanoramaModule.Panorama.ttRight) {

                    PanoramaModule.Panorama.iFrameElement.contentWindow.postMessage({ ttRight: true }, '*');

                }

                if (PanoramaModule.Panorama.ttBottom) {

                    PanoramaModule.Panorama.iFrameElement.contentWindow.postMessage({ ttBottom: true }, '*');

                }

                // When the frame is loaded post message to open new coordinates

                PanoramaModule.Panorama.iFrameElement.contentWindow.postMessage({ coordinates: [x, y], orientation: orientation }, '*');

            }

        },



        // Opens the panorama iframe

        OpenPanoramaFrame: function (coordinates, orientation) {

            // If source empty fill url

            if (PanoramaModule.Panorama.iFrameElement.src == window.location.href || PanoramaModule.Panorama.iFrameElement.src == undefined) {

                PanoramaModule.Panorama.iFrameElement.src = `${PanoramaModule.Panorama.iFrameRequestUrl}&coordinates=${coordinates[0]},${coordinates[1]}`;

                if (orientation) {

                    if (orientation.yaw) {

                        PanoramaModule.Panorama.iFrameElement.src += `&yaw=${orientation.yaw}`;

                    }

                    if (orientation.pitch) {

                        PanoramaModule.Panorama.iFrameElement.src += `&pitch=${orientation.pitch}`;

                    }

                    if (orientation.fov) {

                        PanoramaModule.Panorama.iFrameElement.src += `&fov=${orientation.fov}`;

                    }

                }

            }

            // If src full send message

            else {

                // When the frame is loaded post message to open new coordinates

                PanoramaModule.Panorama.iFrameElement.contentWindow.postMessage({ coordinates: coordinates, orientation: orientation }, '*');

            }

            // Unhide it

            PanoramaModule.Panorama.panoramaContainer.style.display = '';

            // Add event listener to close button

            PanoramaModule.Panorama.closeButton.addEventListener('click', PanoramaModule.Panorama.HidePanoramaFrame);

            // Get the marker

            const marker = document.getElementById('panorama-view-cone');

            // If there is a marker

            if (marker != null) {

                // Enable marker

                marker.style.display = '';

            }

        },



        // Hides the panorama frame

        HidePanoramaFrame: function (event) {

            // Hide container

            PanoramaModule.Panorama.panoramaContainer.style.display = 'none';

            // Get the marker

            const marker = document.getElementById('panorama-view-cone');

            // If there is a marker

            if (marker != null) {

                // Remove marker

                marker.style.display = 'none';

            }

        },



        /**

         * @param {Object} map The map object, after initialized using: new maplibregl.Map

         * @param {Object} maplibregl The maplibregl object that is imported

         */

        // Configure MapLibre map for panorama usage, call this method in map.onload

        ConfigureMapLibreMap: function (map, maplibregl) {

            PanoramaModule.Panorama.mapLibreMap = map;

            // If keyboard movement is on

            if (PanoramaModule.Panorama.keyboardMovementEnabled == true) {

                // Disable map keyboard controls

                map.keyboard.disable();

            }

            // If map is clickable

            if (PanoramaModule.Panorama.mapClickEnabled != false) {

                // Open panorama on click location

                map.on('click', PanoramaModule.Panorama.MapLibreClickEvent);

            }

            // If marker is enabled (exists)

            if (PanoramaModule.Panorama.markerImage != null) {

                // Create new marker

                const newMarker = document.createElement('div');

                newMarker.id = 'panorama-view-cone';

                const img = new Image();

                img.addEventListener("load", function () {

                    newMarker.style.width = img.naturalWidth + 'px';

                    newMarker.style.height = img.naturalHeight + 'px';

                    newMarker.style.backgroundImage = 'url(' + img.src + ')';

                });

                img.src = PanoramaModule.Panorama.markerImage;

                PanoramaModule.Panorama.maplibreMarker = new maplibregl.Marker(newMarker);

                // When new location or angle comes as message

                window.addEventListener('message', PanoramaModule.Panorama.MapLibreMessageEvent)

            }

        },

        // Event for maplibre map click

        MapLibreClickEvent: function (e) {

            // If checkbox is checked

            if (PanoramaModule.Panorama.panoramaClickCheckBox.checked == true) {

                // Open panorama on location

                PanoramaModule.Panorama.OpenPanoramaOnLocation(e.lngLat.lng, e.lngLat.lat);

            }

        },

        // Event for maplibre event-marker

        MapLibreMessageEvent: function (e) {

            if (e.data.angle != undefined && e.data.coordinates != undefined) {

                // If panorama is open

                if (PanoramaModule.Panorama.panoramaContainer.style.display != 'none') {

                    // Get the marker

                    const marker = document.getElementById('panorama-view-cone');

                    // If there is a marker

                    if (marker != null) {

                        // Get its coordinates

                        const markerCoordinates = PanoramaModule.Panorama.maplibreMarker.getLngLat();

                        // If the new coordinates are different than the markers coordinates

                        if (markerCoordinates && markerCoordinates.lng != parseFloat(e.data.coordinates[0]) && markerCoordinates.lat != parseFloat(e.data.coordinates[1])) {

                            // Center map

                            PanoramaModule.Panorama.coordinates = e.data.coordinates;

                            PanoramaModule.Panorama.mapLibreMap.flyTo({ center: e.data.coordinates });

                        }

                    }

                    else {

                        PanoramaModule.Panorama.maplibreMarker.setLngLat([29, 41]).addTo(PanoramaModule.Panorama.mapLibreMap);

                    }

                    PanoramaModule.Panorama.maplibreMarker.setLngLat(e.data.coordinates).setRotation(e.data.angle);

                }

            }

        },



        /**

         * @param {String} properties.token The request token

         * @param {String} properties.environment The mode that the panorama will run on, default is deploy, test and development also available

         * @param {String} properties.panoramaType Default: 2013-2018 - The type of panorama, empty string for 2013-2018, 2018 for 2018 and 2013 for 2013

         * @param {String} properties.panoramaContainerId Default: panorama-container - The container that includes the panorama and its related controls

         * @param {String} properties.panoramaIframeId Default: panorama-iframe - Id of the iframe element

         * @param {String} properties.panoramaCloseButtonId Default: panorama-close-button - Id of the button that closes the panorama container

         * @param {Boolean} properties.mapClickEnabled Default: false - The parameter that decides whether a click on the map will open the panorama, loads default checkbox with id: "panorama-checkbox"

         * @param {String} properties.panoramaCheckBoxElementId The checkbox that enables "click map open panorama".

         * @param {String} properties.markerImage Default: https://cbspanorama.ibb.gov.tr/images/panoiconBlue.png - The image for the view cone

         * @param {Boolean} properties.keyboardControlsEnabled Default: true - Enables or disables keyboard movement inside the panorama.

         * @param {object} properties.orientation {yaw: number, pitch: number, fov: number}

         * @param {double[]} properties.coordinates {array with [x,y]}

         * @param {Boolean} properties.timeTravelRight {If time travel is to the right}

         * @param {Boolean} properties.timeTravelBottom {If time travel is to the bottom}

        */

        // Configure panorama

        ConfigurePanorama: function (properties) {

            // Set panoramaType to empty string if null

            if (properties.panoramaType === undefined) {

                properties.panoramaType = '';

            }



            //#region environment

            // Set request url according to env

            switch (properties.environment) {

                case "development":

                    PanoramaModule.Panorama.iFrameRequestUrl = 'https://localhost:44314/panorama/panorama' + properties.panoramaType + '/?token=' + properties.token;

                    break;

                case "test":

                    PanoramaModule.Panorama.iFrameRequestUrl = 'https://cbspanoramatest.ibb.gov.tr/panorama/panorama' + properties.panoramaType + '/?token=' + properties.token;

                    break;

                default:

                    PanoramaModule.Panorama.iFrameRequestUrl = 'https://cbspanorama.ibb.gov.tr/panorama/panorama' + properties.panoramaType + '/?token=' + properties.token;

            }

            //#endregion



            //#region  panoraa container

            // Get panorama container from document

            switch (properties.panoramaContainerId) {

                case undefined:

                    PanoramaModule.Panorama.panoramaContainer = document.getElementById('panorama-container');

                    break;

                default:

                    PanoramaModule.Panorama.panoramaContainer = document.getElementById(properties.panoramaContainerId);

            }

            // Hide container

            PanoramaModule.Panorama.panoramaContainer.style.display = 'none';

            //#endregion



            //#region panorama iframe

            // Get panorama iframe

            switch (properties.panoramaIframeId) {

                case undefined:

                    PanoramaModule.Panorama.iFrameElement = document.getElementById('panorama-iframe');

                    break;

                default:

                    PanoramaModule.Panorama.iFrameElement = document.getElementById(properties.panoramaIframeId);

            }

            //#endregion



            //#region close button

            // Get close button from document

            switch (properties.panoramaCloseButtonId) {

                case undefined:

                    PanoramaModule.Panorama.closeButton = document.getElementById('panorama-close-button');

                    break;

                default:

                    PanoramaModule.Panorama.closeButton = document.getElementById(properties.panoramaCloseButtonId);

            }

            //#endregion



            //#region map click 

            switch (properties.mapClickEnabled) {

                case true:

                    PanoramaModule.Panorama.mapClickEnabled = properties.mapClickEnabled;

                    switch (properties.panoramaClickCheckBox) {

                        case undefined:

                            PanoramaModule.Panorama.panoramaClickCheckBox = document.getElementById('panorama-checkbox');

                            break;

                        default:

                            PanoramaModule.Panorama.panoramaClickCheckBox = document.getElementById(properties.panoramaCheckBoxElementId);

                    }

                    switch (properties.mode) {

                        case "development":

                            PanoramaModule.Panorama.markerImage = 'https://localhost:44314/images/panoiconBlue.png';

                            break;

                        case "test":

                            PanoramaModule.Panorama.markerImage = 'https://cbspanoramatest.ibb.gov.tr/images/panoiconBlue.png';

                            break;

                        default:

                            PanoramaModule.Panorama.markerImage = 'https://cbspanorama.ibb.gov.tr/images/panoiconBlue.png';

                    }

                    break;

                default:

                    PanoramaModule.Panorama.mapClickEnabled = false;

            }

            //#endregion



            //#region marker image

            // If marker image is specified

            switch (properties.markerImage) {

                case undefined:

                    switch (properties.environment) {

                        case "development":

                            PanoramaModule.Panorama.markerImage = 'https://localhost:44314/images/panoiconBlue.png';

                            break;

                        case "test":

                            PanoramaModule.Panorama.markerImage = 'https://cbspanoramatest.ibb.gov.tr/images/panoiconBlue.png';

                            break;

                        default:

                            PanoramaModule.Panorama.markerImage = 'https://cbspanorama.ibb.gov.tr/images/panoiconBlue.png';

                    }

                    break;

                default:

                    PanoramaModule.Panorama.markerImage = properties.markerImage;

            }

            switch (properties.keyboardMovementEnabled) {

                case undefined:

                    PanoramaModule.Panorama.keyboardMovementEnabled = true;

                    break;

                default:

                    PanoramaModule.Panorama.keyboardMovementEnabled = properties.keyboardControlsEnabled;

            }

            if (properties.timeTravelRight) {

                PanoramaModule.Panorama.ttRight = properties.timeTravelRight;

            }

            if (properties.timeTravelBottom) {

                PanoramaModule.Panorama.ttBottom = properties.timeTravelBottom;

            }

            //#endregion



            // Catch the panorama loaded message

            window.addEventListener('message', PanoramaModule.Panorama.MessageEvent);

        },

        // Event to catch load

        MessageEvent: function (e) {

            if (e.data.load === true) {

                PanoramaModule.Panorama.panoramaLoaded = true;

            }

            if (e.data.angle && e.data.pitch && e.data.fov) {

                PanoramaModule.Panorama.orientation = { yaw: e.data.angle, pitch: e.data.pitch, fov: e.data.fov }

            }

        },

        GetOrientation() {

            return PanoramaModule.Panorama.orientation;

        },

        GetCoordinates() {

            return PanoramaModule.Panorama.coordinates;

        },

        // Resets this class

        Reset: function () {

            // Remove event listener

            window.removeEventListener('message', PanoramaModule.Panorama.MessageEvent);

            // If maplibre

            if (PanoramaModule.Panorama.mapLibreMap !== null) {

                window.removeEventListener('message', PanoramaModule.Panorama.MapLibreMessageEvent);

            }

            PanoramaModule.Panorama.iFrameElement.src = "";

            PanoramaModule.Panorama.iFrameRequestUrl = null;

            PanoramaModule.Panorama.panoramaContainer = null;

            PanoramaModule.Panorama.iFrameElement = null;

            PanoramaModule.Panorama.panoramaClickCheckBox = null;

            PanoramaModule.Panorama.closeButton = null;

            PanoramaModule.Panorama.keyboardMovementEnabled = null;

            PanoramaModule.Panorama.mapClickEnabled = null;

            PanoramaModule.Panorama.markerImage = null;

            PanoramaModule.Panorama.mapLibreMap = null;

            PanoramaModule.Panorama.maplibreMarker = null;

            PanoramaModule.Panorama.orientation = null;

        }

    }

}